package net.t2code.opsecurity.config;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Language;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.*;

public class FileSelect {

    private static ArrayList<String> defaultLanguages = new ArrayList<>(Arrays.asList("german", "english"));

    public static void selectLanguage() {
        long long_ = System.currentTimeMillis();

        for (String language : defaultLanguages) {
            File config = new File(Main.getPath(), "languages/" + language + ".yml");
            YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
            for (Language value : Language.values()) {
                if (!yamlConfiguration.contains(value.path)) {
                    switch (language) {
                        case "german":
                            yamlConfiguration.set(value.path, value.german);
                            break;
                        case "english":
                            yamlConfiguration.set(value.path, value.english);
                            break;
                    }
                }
            }
            T2Cdebug.debug(Main.getPlugin(), "save: " + language);
            try {
                yamlConfiguration.save(config);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        String selectMSG;
        File config = new File(Main.getPath(), "languages/" + Config.VALUES.language.getValue() + ".yml");
        T2Cdebug.debug(Main.getPlugin(), config.getAbsolutePath());
        if (!config.isFile()) {
            T2Csend.console(Util.getPrefix());
            T2Csend.console(Util.getPrefix() + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Util.getPrefix() + " §4The selected §c" + Config.VALUES.language.getValue() + " §4language file was not found.");
            T2Csend.console(Util.getPrefix() + " §6The default language §eEnglish §6is used!");
            T2Csend.console(Util.getPrefix() + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Util.getPrefix());
            config = new File(Main.getPath(), "languages/" + "english.yml");
            selectMSG = "english";
        } else selectMSG = Config.VALUES.language.getValue().toString();
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        for (Language value : Language.values()) {
            T2Cdebug.debug(Main.getPlugin(), "Select: File: " + config.getName() + " Path: " + value.path);
            value.value = T2Creplace.replace(Util.getPrefix(), yamlConfiguration.getString(value.path));
        }
        T2Ctemplate.onStartMsg(Util.getPrefix(),"§2Language successfully selected to: §6" + selectMSG + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
