// This class was created by JaTiTV.

package net.t2code.opsecurity.config.permissionWhitelist;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriter;
import net.t2code.t2codelib.T2CconfigItem;
import org.bukkit.configuration.ConfigurationSection;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class PermissionWhitelist {

    public enum VALUES implements T2CconfigItem {

        enable("permissionWhitelist.enable", false, true),
        playerWithPermissionKick("permissionWhitelist.playerWithPermissionKick", true, true),
        permissions("permissionWhitelist.permissions", Arrays.asList("*", "t2c.opsecurity.admin"), true),
        customCommandsEnable("permissionWhitelist.customCommands.enable", false, true),
        customCommandsCommands("permissionWhitelist.customCommands.commands", Arrays.asList("lp user [player] permission unset *", "lp user [player] permission unset t2c.opsecurity.admin"), true),

        playerSection("permissionWhitelist.whitelist", null, true),
        player1name("permissionWhitelist.whitelist.player1.name", "player1", false),
        player1uuid("permissionWhitelist.whitelist.player1.uuid", "00000000000000000000000000000000", false),
        player2name("permissionWhitelist.whitelist.player2.name", "player2", false),
        player2uuid("permissionWhitelist.whitelist.player2.uuid", "00000000000000000000000000000000", false),

        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final List<String> comments;

        VALUES(String path, Object value, boolean forceSet, String... comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set() {
        long long_ = System.currentTimeMillis();
        T2CconfigWriter.createConfig(new File(Main.getPath(), "permissionWhitelist.yml"), VALUES.values(), Util.getConfigLogo());
        player();

        T2Ctemplate.onStartMsg(Util.getPrefix(), "§2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }


    private static void player() {
        ConfigurationSection section = (ConfigurationSection) VALUES.playerSection.getValue();
        for (String key : section.getConfigurationSection("").getKeys(false)) {
            String name = section.getString(key + ".name");
            PlayerObject playerObject = new PlayerObject(
                    name,
                    section.getString(key + ".uuid").replace("-", ""));
            PlayerCache.getOpHashMap().put(name, playerObject);
        }
    }
}
